import(Module_Defines);
import(Module_DataTypes);
import(Module_MapWho);
import(Module_Person);
import(Module_System);
import(Module_Game);
import(Module_Objects);
import(Module_Globals);
import(Module_Map);
import(Module_Commands);
import(Module_Sound);
import(Module_Level);
import(Module_Helpers);
import(Module_String);
import(Module_Table);
import(Module_Math);
import(Module_Draw)
import(Module_Shapes)
import(Module_Package)
import(Module_Players);
include("LibBuildings.lua")

local ReincPos = {
	MAP_XZ_2_WORLD_XYZ(74, 70),
	MAP_XZ_2_WORLD_XYZ(74, 182),
	MAP_XZ_2_WORLD_XYZ(178, 182),
	MAP_XZ_2_WORLD_XYZ(178, 70),
	MAP_XZ_2_WORLD_XYZ(84, 254),
	MAP_XZ_2_WORLD_XYZ(168, 254)
}

local teamOne = {}
local teamTwo = {}

_gsi = gsi()

firstQuickRespawnOwner = 0
secondQuickRespawnOwner = 0

firstTemplePlans = 0
secondTemplePlans = 0

local gDeadShamans = {}
	
for i, k in ipairs(ReincPos) do
	local me = world_coord3d_to_map_ptr(k)
	me.MapWhoList:processList(function(t)
		if (t.Type == T_PERSON) then
			if (t.Model == M_PERSON_MEDICINE_MAN) then
				if (i == 1 or i == 2 or i == 5) then
					table.insert(teamOne, t.Owner)
				end

				if (i == 3 or i == 4 or i == 6) then
					table.insert(teamTwo, t.Owner)
				end

				if (i == 5) then
					firstQuickRespawnOwner = t.Owner --Blue

					DisableBuilding(t.Owner, M_BUILDING_WARRIOR_TRAIN)
					DisableBuilding(t.Owner, M_BUILDING_SUPER_TRAIN)
					EnableBuilding(t.Owner, M_BUILDING_TEMPLE)
				end
				if (i == 6) then
					secondQuickRespawnOwner = t.Owner --Red

					DisableBuilding(t.Owner, M_BUILDING_WARRIOR_TRAIN)
					DisableBuilding(t.Owner, M_BUILDING_SUPER_TRAIN)
					EnableBuilding(t.Owner, M_BUILDING_TEMPLE)
				end
				
			end
		end
	return true
	end)
end

function OnTurn()
	if (EVERY_2POW_TURNS(2)) then
		for k,v in ipairs(gDeadShamans) do
			if (v ~= nil) then 
				if (v.Model == M_INTERNAL_SOUL_CONVERT_2) then 
					if (v.u.SoulConvert.CurrModel == M_PERSON_MEDICINE_MAN) then
						if (v.SubState == SS_SC2_SOUL_IN_LIMBO) then 
						
							if (v.Owner == firstQuickRespawnOwner) then -- cyan
								v.u.SoulConvert.Count = 60;
							elseif (v.Owner == secondQuickRespawnOwner) then -- magenta
								v.u.SoulConvert.Count = 60;
							end
							
							table.remove(gDeadShamans,k)
						end
					else 
						table.remove(gDeadShamans,k)
					end
				else 
					table.remove(gDeadShamans,k)
				end
			else 
				table.remove(gDeadShamans,k)
			end
		end
	end
end

function OnCreateThing(t)
	if (t.Type == T_INTERNAL) then 
		if (t.Model == M_INTERNAL_SOUL_CONVERT_2) then 
			if (t.u.SoulConvert.CurrModel == M_PERSON_MEDICINE_MAN) then
				table.insert(gDeadShamans, t)
			end
		end
	end
end

--Allying Team 1
for i, v in ipairs(teamOne) do
	for k, t in ipairs(teamOne) do
      set_players_allied(v, t)
  end
end

-- Allying Team 2
for i, v in ipairs(teamTwo) do
    for k, t in ipairs(teamTwo) do
        set_players_allied(v, t)
    end
end